"""Remove login_session_id from OAuthSession

Revision ID: deb3261a9742
Revises: 095306ad19a5
Create Date: 2023-05-17 09:11:08.237199

"""
import sqlalchemy as sa
from alembic import op

import fief

# revision identifiers, used by Alembic.
revision = "deb3261a9742"
down_revision = "095306ad19a5"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    connection = op.get_bind()
    if connection.dialect.name == "postgresql":
        op.drop_constraint(
            "fief_oauth_sessions_login_session_id_fkey",
            "fief_oauth_sessions",
            type_="foreignkey",
        )
        op.drop_column("fief_oauth_sessions", "login_session_id")
    elif connection.dialect.name == "mysql":
        op.drop_constraint(
            "fief_oauth_sessions_ibfk_1", "fief_oauth_sessions", type_="foreignkey"
        )
        op.drop_column("fief_oauth_sessions", "login_session_id")
    elif connection.dialect.name == "sqlite":
        with op.batch_alter_table("fief_oauth_sessions") as batch_op:
            batch_op.drop_column("login_session_id")

    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column(
        "fief_oauth_sessions",
        sa.Column("login_session_id", sa.UUID(), autoincrement=False, nullable=False),
    )
    op.create_foreign_key(
        "fief_oauth_sessions_login_session_id_fkey",
        "fief_oauth_sessions",
        "fief_login_sessions",
        ["login_session_id"],
        ["id"],
        ondelete="CASCADE",
    )
    # ### end Alembic commands ###
